<?php

/**
 * co_eta_mod_ep actions.
 *
 * @package    contratacion
 * @subpackage co_eta_mod_ep
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class co_eta_mod_epActions extends sfActions
{
 /**
  * Executes index action
  *
  * @param sfRequest $request A request object
  */
  
    
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by descripcion_tipodocumento';
        }
        
        try {
            
            $id_modalidad_sel = $request['id_modalidad_sel'];
            $id_seleccion_ep = $request['id_seleccion_ep'];
            
            $this->logMessage("ID_MODALIDAD_SEL".$id_modalidad_sel);
                
            
            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);
            
            $sql = <<<EOD
                    select count(*) as count from (
select tab0.*, tab1.descripcion as descripcion_etapa,tab1.aplica_tiempo, tab1.aplica_numero, tab1.aplica_desde_hasta, tab1.aplica_oferentes, tab1.aplica_adjudicatario,tab3.descripcion as descripcion_modalidad, tab3.prefijo as prefijo_modalidad

from co_etapa_modalidad tab0
left join co_etapa tab1 ON tab1.id_etapa = tab0.id_etapa
left join co_modalidad_sel tab3 ON tab3.id_modalidad_sel = tab0.id_modalidad_sel

where tab0.id_modalidad_sel = $id_modalidad_sel and tab0.orden = (select min(ordenar.orden) from co_etapa_modalidad ordenar where ordenar.id_modalidad_sel = $id_modalidad_sel and not exists (select selec.id_etapa_modalidad 
    from co_seleccion_etapa selec where selec.id_seleccion_ep = $id_seleccion_ep and selec.id_etapa_modalidad = ordenar.id_etapa_modalidad))
                    )
EOD;
            
        $total_record_count = CN_TABLE::executeSQL($sql);
        $total_record_count = $total_record_count[0]["count"];
        
        
        $sql = <<<EOD
                SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (
select tab0.*, tab1.descripcion as descripcion_etapa,tab1.aplica_tiempo, tab1.aplica_numero, tab1.aplica_desde_hasta, tab1.aplica_oferentes, tab1.aplica_adjudicatario,tab3.descripcion as descripcion_modalidad, tab3.prefijo as prefijo_modalidad

from co_etapa_modalidad tab0
left join co_etapa tab1 ON tab1.id_etapa = tab0.id_etapa
left join co_modalidad_sel tab3 ON tab3.id_modalidad_sel = tab0.id_modalidad_sel

where tab0.id_modalidad_sel = $id_modalidad_sel and tab0.orden = (select min(ordenar.orden) from co_etapa_modalidad ordenar where ordenar.id_modalidad_sel = $id_modalidad_sel and not exists (select selec.id_etapa_modalidad 
    from co_seleccion_etapa selec where selec.id_seleccion_ep = $id_seleccion_ep and selec.id_etapa_modalidad = ordenar.id_etapa_modalidad))
                $sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            
        $resultado = CN_TABLE::executeSQL($sql);
        


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[documento_modalidad] Consulta exitosa.");
            
            
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
        
        
    }
}
